/*
 *
 *  Created on: 12.11.2011
 *      Author: klausj
 */

#ifndef JNM_VIDEOSINK_H_
#define JNM_VIDEOSINK_H_

#include <glib-object.h>
#include "jnm_decodingplayer.h"

//#include <gst/gst.h>
//#include <gst/video/gstvideosink.h>

#define JNM_TYPE_VIDEOSINK         (jnm_videosink_get_type ())

typedef struct _JnmVideoSink        JnmVideoSink;
typedef struct _JnmVideoSinkClass   JnmVideoSinkClass;

typedef struct _JnmVideoSinkPrivate JnmVideoSinkPrivate;

struct _JnmVideoSinkPrivate{

};

/* object */
struct _JnmVideoSink
{
   // GObject parent_instance;
    GstVideoSink parent_instance;
    /* public */
    //int public_int;
    //JavaVM *javaVM;
    GstPadTemplate *gstSinkPadTemplate;
    JnmDecodingPlayer *mediaDecodingPlayer;
    /*< private >*/
    JnmVideoSinkPrivate *priv;
};

/* class */
struct _JnmVideoSinkClass
{
    //GObjectClass parent_class;

    /* class members */

    /* Virtual public method */
    //void (*do_action_virt) (JnmVideoSink *self, gchar *msg);
    GstVideoSinkClass parent_class;
    //GstFlowReturn  (*show_frame) (GstVideoSink *video_sink, GstBuffer *buf);
};

struct _JnmVideosinkPrivate
{
  //int hsize;
  gchar *msg;
};

gboolean      jnm_videosink_set_caps (GstBaseSink *, GstCaps *);
GstFlowReturn  jnm_videosink_show_frame(GstVideoSink *video_sink, GstBuffer *buf);

GType jnm_videosink_get_type ();

#endif
